#!/bin/bash
rm /root/snap-*
file_tmp="/tmp/newsnap_info"
file="/root/.func/status"
res=$(docker exec miner miner info height)
if [ "$res" = "" ];then exit 0;fi
temp=$(echo $res | grep 127.0.0.1)
if [ "$temp" != "" ];then exit 0;fi
temp=$(echo $res | grep Error)
if [ "$temp" != "" ];then exit 0;fi

miner_height=$(echo $res | awk '{print $2}')


snap_quay=$(curl -s  -H 'Cache-Control: no-cache' https://msync.syncrob.it/  --connect-timeout 10 --write-out '\nHTTP_Response:%{http_code}')
snap_response=$(echo "$snap_quay" | grep "HTTP_Response" | cut -d":" -f2)
if [[ $snap_response -eq 200 ]];
then
	snap_quay=$(echo "$snap_quay" | grep -v HTTP_Response)
	newsnap=$(echo $snap_quay | jq .fileUri | awk -F- '{print $2}' | awk -F. '{print $1}')
	echo newest snap : $newsnap
	newsnap_file=$(echo $snap_quay | jq .arkUri | awk -F'it/' '{print $2}' | awk -F\" '{print $1}')
	if [ $miner_height -eq 1 ]
	then
		miner_height=$(ls /root/miner_data/snap/ | awk -F'-' '{print $2}' | awk -F'.' '{print $1}')
		if [ "$miner_height" = "" ];then miner_height=1;fi
	fi
	height_diff=$(expr "$newsnap" - "$miner_height")
	if [ $height_diff -gt 200 ]
	then
		echo block diff too large, download and take snap-$newsnap
		snapurl=$(echo $snap_quay | jq .arkUri | awk -F\" '{print $2}')
		snap_sha256=$(echo $snap_quay | jq .arkCheckSum.sha256 | awk -F\" '{print $2}')
		cd /root/
		echo $snapurl
		wget "$snapurl"
		snap_sha256_local=$(sha256sum $newsnap_file | awk -F' '  '{print $1}')
		echo $snap_sha256
		echo $snap_sha256_local
		if [ "$snap_sha256" = "$snap_sha256_local" ]
		then
			xz -dk $newsnap_file
			mv  snap-"$newsnap"_ark.bin /root/miner_data/snap/snap-$newsnap
			rm /root/snap-*
			/root/.func/loadanysnap.sh snap-$newsnap
			exit
		fi
	fi
fi

rm /root/snap-*
current_height=$(curl -k -s https://api.helium.io/v1/blocks/height --connect-timeout 10 | jq .data.height)
if [ "$current_height" = "" ]
then
   echo $(date)":height "$miner_height
   exit 0
fi

height_diff=$(expr "$current_height" - "$miner_height")

if [ $height_diff -gt 200 ] || [ $miner_height -eq 1 ]
then
  echo $(date):height $miner_height diff $height_diff sync height
  status=$(cat $file)
  if [ "$status" = "1" ]
  then
     sed -i "s/1/0/g" $file
  fi
else
  echo $(date): height $miner_height diff $height_diff sync done
  status=$(cat $file)
  if [ "$status" = "0" ]
  then
     sed -i "s/0/1/g" $file
  fi
fi
